<script lang="ts">
    import type { SimulationNode } from './simulation'
    import { opacity } from '../color'

    export let node: SimulationNode
    export let scale = 1
    $: fontSize = Math.min(scale, 1)

    $: nodeRadius = 10 + node.proportion * 20
    $: textAnchor = node.x < 0 ? 'end' : 'start'
    $: textX = node.x + Math.sign(node.x) * (nodeRadius + 4)
</script>

<text text-anchor={textAnchor} dominant-baseline="middle"
      opacity={$opacity(node.index)}
      on:dblclick
      stroke-width={4 * fontSize}
      stroke-linejoin="round"
      font-size={fontSize + 'rem'}
      class="stroke-white paint-order-stroke pointer-events-none"
      x={textX} y={node.y}>
    {node.label}
</text>
